/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2013 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014,2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_config.h 619 2014-03-18 06:10:27Z nmir-saito $
 */


/*
 *      ¸⥸塼ARMѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_CORE_CONFIG_H
#define TOPPERS_CORE_CONFIG_H

/*
 *  ARM¸
 */
#include "arm.h"

/*
 *  顼åˡλ
 */
#define CHECK_STKSZ_ALIGN	8	/* åΥ饤ñ */
#ifndef  __thumb__
#define CHECK_FUNC_ALIGN	4	/* ؿΥ饤ñ */
#endif /* __thumb__ */
#define CHECK_FUNC_NONNULL		/* ؿNULLå */
#define CHECK_STACK_ALIGN	4	/* åΰΥ饤ñ */
#define CHECK_STACK_NONNULL		/* åΰNULLå */
#define CHECK_MPF_ALIGN		4	/* ĹסΰΥ饤ñ */
#define CHECK_MPF_NONNULL		/* ĹסΰNULLå */
#define CHECK_MB_ALIGN		4	/* ΰΥ饤ñ */

/*
 *  CPUåȤCPSRΥѥ
 */
#ifndef CPSR_CPULOCK
#define CPSR_CPULOCK     (CPSR_IRQ_BIT)
#endif  /* CPSR_CPULOCK */

/*
 *  ߥåȤCPSRΥѥ
 */
#define CPSR_INTLOCK     (CPSR_FIQ_BIT|CPSR_IRQ_BIT)

/*
 *  CPSR˾˥åȤѥ
 */
#ifndef CPSR_ALWAYS_SET
#define CPSR_ALWAYS_SET  0x00
#endif  /* CPSR_ALWAYS_SET */

/*
 *  㳰ֹ
 */
#define EXCH_NO_RESET     0
#define EXCH_NO_UNDEF     1
#define EXCH_NO_SVC       2
#define EXCH_NO_PABORT    3
#define EXCH_NO_DABORT    4
#define EXCH_NO_IRQ       5
#define EXCH_NO_FIQ       6

/*
 *  㳰θĿ
 */  
#define TNUM_EXCH         7

#ifndef TOPPERS_MACRO_ONLY

/*
 *  󥿥ƥѤΥå
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char *)(istk) + (istksz)))

/*
 *  ץåü̿Υ饤ؿ
 */
#include <core_insn.h>


/*
 *  TOPPERSɸ߽ǥμ¸
 *
 *  IRQ򥫡ͥ⡤FIQ򥫡ͥγߤȤư
 * 
 *  ARM¸ǤϡTOPPERSɸ߽ǥΤCPUå
 *  Τߤ갷ͥ٥ޥ׵ػߥե饰˴ؤ
 *  ϡƥåȰ¸Ǽ갷
 */

/*
 *  ƥȻȤΤѿ
 */
extern uint32_t excpt_nest_count; /* 㳰ʳ/CPU㳰ˤΥͥȲΥ */

/*
 *  ƥȤλ
 *
 *  ARMǤϡƥȤ󥿥ƥȤξ򥹡ѡ
 *  Х⡼ɤư롥ΤᡤCPSRƤǤȽ̤Ǥʤ
 *  Τᡤ㳰ʳ/CPU㳰ˤΥͥȲ򥫥Ȥѿ
 *  excpt_nest_countˤѰդ㳰ǥ󥯥Ȥ뤳
 *  ǡƥȤȽꤹ롥
 */
Inline bool_t
sense_context(void)
{
	return(excpt_nest_count > 0U);
}

/*
 *  CPUå֤ؤΰܹ
 */
Inline void
x_lock_cpu(void)
{
	set_sr(current_sr() | CPSR_CPULOCK | CPSR_ALWAYS_SET);
	/* ƥ륻ǥ꤬񤭴ǽ */
	ARM_MEMORY_CHANGED;
}

#define t_lock_cpu()   x_lock_cpu()
#define i_lock_cpu()   x_lock_cpu()

/*
 *  CPUå֤β
 */
Inline void
x_unlock_cpu(void)
{
	/* ƥ륻ǥ꤬񤭴ǽ */
	ARM_MEMORY_CHANGED;
	set_sr((current_sr() & (~CPSR_CPULOCK)) | CPSR_ALWAYS_SET);
}

#define t_unlock_cpu() x_unlock_cpu()
#define i_unlock_cpu() x_unlock_cpu()

/*
 *  CPUå֤λ
 */
Inline bool_t
x_sense_lock(void)
{
	return((current_sr() & CPSR_CPULOCK) == CPSR_CPULOCK);
}

#define t_sense_lock() x_sense_lock()
#define i_sense_lock() x_sense_lock()


/*
 *  ɥ롼פμ
 */
Inline void
idle_loop(void)
{
	x_unlock_cpu();
    Asm("":::"memory");
	x_lock_cpu();
}


/*
 *  ǥѥå
 */

/*
 *  ǹ̥ͥؤΥǥѥåcore_support.S
 *
 *  dispatchϡƥȤƤӽФ줿ӥ
 *  ƤӽФ٤ΤǡƥȡCPUå֡ǥѥ
 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
 *  Фʤʤ
 */
extern void dispatch(void);

/*
 *  ǥѥåưϡcore_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡ʳߥå֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void start_dispatch(void) NoReturn;

/*
 *  ߤΥƥȤΤƤƥǥѥåcore_support.S
 *
 *  exit_and_dispatchϡext_tskƤӽФ٤Τǡƥ
 *  ȡCPUå֡ǥѥåľ֡ʥǥΡ˳ͥ
 *  ٥ޥ֤ǸƤӽФʤФʤʤ
 */
extern void exit_and_dispatch(void) NoReturn;

/*
 *  ͥνλθƽФcore_support.S
 *
 *  call_exit_kernelϡͥνλ˸ƤӽФ٤Τǡ󥿥
 *  ƥȤڤ괹ơͥνλexit_kernelˤƤӽ
 *  
 */
extern void call_exit_kernel(void) NoReturn;

/*
 *  calltexϻѤʤ
 */
#define OMIT_CALLTEX
     
/*
 *  CPU㳰ϥɥϿѥơ֥
 */
extern const FP exch_tbl[TNUM_EXCH];

/*
 * å¸˴ޤޤɸ㳰ǽνѤʤ
 */
#define OMIT_INITIALIZE_EXCEPTION

/*
 * CPU㳰ϥɥν
 */
Inline void
initialize_exception(void)
{
}

/*
 *  CPU㳰ȯΥƥ֤λ
 */

/*
 *  CPU㳰ȯΥƥȤλ
 *
 *  CPU㳰ȯΥƥȤƥȤλfalse
 *  Ǥʤtrue֤
 */
Inline bool_t
exc_sense_context(void *p_excinf)
{
    return((*((uint32_t *) p_excinf)) != 0U);
}

/*
 *  CPU㳰ȯ(ǥ)ͥ٥ޥλ
 */
Inline PRI
exc_get_ipm(void *p_excinf)
{
    return((PRI)(*(((uint32_t *)(p_excinf)) + 1)));
}

/*
 *  CPU㳰ȯCPSRμ
 */
Inline uint32_t
exc_get_sr(void *p_excinf){
    return(*(((uint32_t *)(p_excinf)) + 2));    
}

/*
 * CPUå֤
 */
Inline bool_t
exc_sense_lock(void *p_excinf){
	return((exc_get_sr(p_excinf) & CPSR_CPULOCK) == CPSR_CPULOCK);
}

/*
 * ߥå֤
 */
Inline bool_t
exc_sense_int_lock(void *p_excinf){
	return((exc_get_sr(p_excinf) & CPSR_INTLOCK) == CPSR_INTLOCK);
}

/*
 *  CPU㳰ȯΥƥȤȳߤΥޥ֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤ
 *  ͥ٥ޥ֤ǤtrueǤʤfalse֤
 *  CPU㳰ͥγ߽ȯˤfalse
 *  ˡ
 *
 */
Inline bool_t
exc_sense_intmask(void *p_excinf)
{
	return(!exc_sense_context(p_excinf)
		   && (exc_get_ipm(p_excinf) == 0U)
		   && !exc_sense_lock(p_excinf)
		   && !exc_sense_int_lock(p_excinf));
}

/*
 *  ץå¸ν
 */
extern void core_initialize(void);

/*
 *  ץå¸νλ
 */
extern void core_terminate(void);

/*
 *  ٥ơ֥̿ᤫ黲Ȥ른襢ɥ쥹
 * start.S
 */
extern void *vector_ref_tbl;

/*
 *  㳰٥ľܼ¹ԤϥɥϿ
 */ 
extern void x_install_exc(EXCNO excno, FP exchdr);

/*
 *  㳰ϥɥ
 */

/*
 *  ̤̿ 㳰ϥɥcore_support.S
 */
extern void undef_handler(void);

/*
 *  SWI 㳰ϥɥcore_support.S
 */
extern void swi_handler(void);

/*
 *  ץեåܡ 㳰ϥɥcore_support.S
 */
extern void prefetch_handler(void);

/*
 *  ǡܡ 㳰ϥɥcore_support.S
 */
extern void data_abort_handler(void);

/*
 *  FIQ 㳰ϥɥcore_support.S
 */
extern void fiq_handler(void);

/*
 *  ̤㳰äν
 */
extern void default_exc_handler(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_CORE_CONFIG_H */
